XIncludeFile "PhysicEngine.pb"
XIncludeFile "basicDrawing.pb"


Global Frames.l
Global Time.d
Global StartTime.d
Global fps.l

Global GUIScreenX.w
Global GUIScreenY.w

Procedure FrameCount()
   Time=ElapsedMilliseconds()-StartTime
   Frames+1
   If Time>1000
      StartTime=ElapsedMilliseconds()
      fps=Frames
      Frames=0
   EndIf
EndProcedure

Procedure CreateBox(x1,y1,x2,y2,m,f.d,e.d,useneutrals=1)
      CreatePEntity(m,f)
      *p1.particle=CreateParticle(entity(),x1,y1)
      *p2.particle=CreateParticle(entity(),x2,y1)
      *p3.particle=CreateParticle(entity(),x2,y2)
      *p4.particle=CreateParticle(entity(),x1,y2)
      CreateConstraint(entity(),*p4,*p3,e)
      CreateConstraint(entity(),*p3,*p2,e)
      CreateConstraint(entity(),*p2,*p1,e)
      CreateConstraint(entity(),*p1,*p4,e) 
      If useneutrals>0
         CreateConstraint(*neutralentity,*p2,*p4,e)
         CreateConstraint(*neutralentity,*p3,*p1,e)
      Else
         CreateConstraint(entity(),*p2,*p4,e)
         CreateConstraint(entity(),*p3,*p1,e)
      EndIf
      Protected rand.w
      rand=Random(1)
      If rand=0
         entity()\type="box"
      ElseIf rand=1
         entity()\type="box2"
      EndIf
EndProcedure
    
Procedure init()
   InitSprite()
   InitKeyboard()
   InitMouse()
   GUIScreenX=640
   GUIScreenY=480
   OpenWindow(0, 0, 0, GUIScreenX, GUIScreenY, "test", #PB_Window_ScreenCentered | #PB_Window_SystemMenu | #PB_Window_SizeGadget)
   OpenWindowedScreen(WindowID(0), 0, 0, GUIScreenX,GUIScreenY,0, 0, 0)
   InitPhysics()
   initCam(GUIScreenX,GUIScreenY)
EndProcedure

Procedure render()
   ClearScreen(RGB(0,0,0))
   StartDrawing(ScreenOutput())
      renderParticles()
      renderConstraints()
      DrawText(0,0,"fps : "+Str(fps),RGB(255,255,255))
      Box(MouseX()-2,MouseY()-2,5,5,RGB(100,0,255)) 
   StopDrawing()
   FlipBuffers()
EndProcedure

Procedure controls()
   ExamineKeyboard()
   ExamineMouse()  
   If KeyboardReleased(#PB_Key_Space)
     CreateBox(ScreenToCoardinateX(MouseX())-20,ScreenToCoardinateY(MouseY())-20,ScreenToCoardinateX(MouseX())+20,ScreenToCoardinateY(MouseY())+20,1,0.8,1)
   EndIf
EndProcedure

Procedure Calculations()
  calcStep()
  controlCam()
EndProcedure



; Main Program

init()

AddHalfSpace(0,GUIScreenY/2,1,0)  ; adding a ground


Repeat
   Repeat
   WEvent=WindowEvent()
      Select WEvent
          Case #PB_Event_CloseWindow
              End
          EndSelect
   Until WEvent=0
   
   controls()
   render()
   
   Calculations()
   FrameCount()
   
Until KeyboardPushed(#PB_Key_Escape)
End
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 90
; FirstLine = 13
; Folding = 1-
; EnableXP
; Executable = drawing 1024x768.exe
; DisableDebugger