Structure vect
   x.d
   y.d
EndStructure

Procedure vect(*v.vect,x.d,y.d)
   *v\x=x
   *v\y=y
EndProcedure

Procedure.d DotProduct(*v1.vect,*v2.vect)
   ProcedureReturn (*v1\x**v2\x+*v1\y**v2\y)
EndProcedure

Procedure Normalize(*v.vect)
   Protected Length.d
   Length=Sqr(*v\x**v\x+*v\y**v\y)
   If Length<>0
      *v\x/Length
      *v\Y/Length
   EndIf
EndProcedure

Procedure.d Length(*v.vect)
   ProcedureReturn Sqr(*v\x**v\x+*v\y**v\y)
EndProcedure

Procedure.d VectAngle(*a.vect,*b.vect)
   ProcedureReturn ACos(DotProduct(*a,*b)/(length(*a)*length(*b)))*180/pi
EndProcedure

Global cross.vect

Procedure Crossa(*p1.vect,*v1.vect,*p2.vect,*v2.vect)
   Protected r.f
   Protected s.f
   Protected threshold.f
   threshold=0.0001
   ;test 0 vector
   If Abs(*v2\x)<threshold And Abs(*v2\y)<threshold Or Abs(*v1\x)<threshold And Abs(*v1\y)<threshold
      ProcedureReturn 0
   EndIf
   ;test ob parallel
   r=*v1\x/*v2\x
   s=*v1\y/*v2\y
   If Abs(r-s)<threshold
      ProcedureReturn 0
   EndIf
   If Abs(*v2\y)>threshold
      r=(*p1\x-*p2\x-(*p1\y-*p2\y)**v2\x/*v2\y)/(*v1\y**v2\x/*v2\y-*v1\x)
      ;s=(*p1\y-*p2\y+r**v2\y)/*v2\y
   Else
      r=(*p2\y-*p1\y)/*v1\y
      ;s=(*p1\x-*p2\x+r*(*v1\x))/*v2\x
   EndIf
   cross\x=*p1\x+r**v1\x
   cross\y=*p1\y+r**v1\y  
EndProcedure
Procedure Cross(*p1.vect,*p2.vect,*p3.vect,*p4.vect)
   Protected a1.d
   Protected b1.d
   Protected c1.d
   
   Protected a2.d
   Protected b2.d
   Protected c2.d
   
   Protected n1.vect
   Protected n2.vect
   
   Protected s.vect
   
   vect(n1,*p1\y-*p2\y,*p2\x-*p1\x)
   vect(n2,*p3\y-*p4\y,*p4\x-*p3\x)
   
   a1=n1\x
   b1=n1\y
   c1=n1\x**p1\x+n1\y**p1\y
   
   a2=n2\x
   b2=n2\y
   c2=n2\x**p3\x+n2\y**p3\y
   
   normalize(n1)
   normalize(n2)
   
   If (n1\x=n2\x And n1\y=n2\y) Or (n1\x=-n2\x And n1\y=-n2\y)
      cross\x=*p1\x
      cross\y=*p1\y
      ProcedureReturn 0
   EndIf
   
   
   If a1=0 And b2=0
      s\x=*p3\x
      s\y=*p1\y
   ElseIf a2=0 And b1=0
      s\x=*p1\x
      s\y=*p3\y
   Else
      If b2<>0 And a1<>0 And (a2-b1)<>0
         s\y= (c2*a1/a2-c1)/(a1*b2/a2-b1)
      Else
         s\y= (c1*a2/a1-c2)/(a2*b1/a1-b2)
      EndIf
      If Abs(a1)>Abs(a2)
         s\x= (c1-b1*s\y)/a1
      Else
         s\x= (c2-b2*s\y)/a2
      EndIf
   EndIf
   
   vect(cross,s\x,s\y)
   ProcedureReturn 1
EndProcedure

Procedure.f DistanceToHalfspace(*hp.vect,*hn0.vect,*p.vect)

   Protected distance.f
   Protected h.vect
        
         vect(h,*p\x-*hp\x,*p\y-*hp\y)
         distance=dotproduct(h,*hn0)
         ProcedureReturn distance

EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 125
; FirstLine = 72
; Folding = Z-
; EnableXP
; Executable = water.exe